package models

import "time"

type Result int32

const (
    NotTested               Result = 0 // change only with schema change
    Accepted                Result = 1
    CompilationError        Result = 2
    MemoryLimitExceeded     Result = 3
    TimeLimitExceeded       Result = 4
    SystemFailDuringTesting Result = 5
    Testing                 Result = 6
)

func (result Result) Valid() error {
    switch result {
    case NotTested, Accepted, TimeLimitExceeded, MemoryLimitExceede, CompilationError, SystemFailDuringTesting:
        return nil
    }
    return lib.ErrBadResult
}
